<?php

function getDatabase($dbname, $username, $password)
{
  try {
    $db = new PDO('mysql:host=localhost;dbname=' . $dbname . ';charset=utf8', $username, $password);
    return $db;
  } catch (Exception $e) {
    var_dump($e);
  }
}

function stopConnections($connections)
{
  foreach ($connections as $c) {
    try {
      $c->closeCursor();
    } catch (Exception $e) {
      continue;
    }
  }
}

function renderForm($name, $db_name, $database, $excludes)
{
  $data_list = $database->query("SELECT * FROM $db_name");
  $data = $data_list->fetchObject();
  global $page;
  echo '<form class="admin-form" action="./?page=' . $page . '" method="POST">';
  echo '<h3> ' . $name . ' </h3>';
  foreach ($data as $k => $v) {
    if (in_array($k, $excludes))
      echo "<input type=\"hidden\" value=\"$v\" name=\"$k\">";
    else
      echo "<input type=\"text\" value=\"$v\" placeholder=\"$k\" name=\"$k\">";
  }
  echo '<input type="submit" name="' . $db_name . '" value="MaJ"/>';
  echo '</form>';
}

function renderFormGroup($name, $db_name, $database, $excludes)
{
  $data_list_lenght = (int) $database->query("SELECT COUNT(*) FROM $db_name")->fetchColumn();
  $data_list = $database->query("SELECT * FROM $db_name")->fetchAll();
  echo '<div class="form-group wrap">';
  echo '<h3> ' . $name . ' </h3>';
  for ($i = 0; $i <= $data_list_lenght; $i++) {
    $ret = '';
    if ($i == $data_list_lenght) {
      $data = $data_list[$i - 1];
    } else {
      $data = $data_list[$i];
    }
    global $page;
    $ret .= '<form class="admin-form" action="./?page=' . $page . '" method="POST">';
    foreach ($data as $k => $v) {
      if (is_int($k)) continue;
      $isAdd = ($i == $data_list_lenght);
      if (in_array($k, $excludes)) {
        if (($k == $excludes[0]) && $isAdd)
          $ret .= "<input type=\"hidden\" value=\"" . ($v + 1) . "\" name=\"$k\">";
        else
          $ret .= "<input type=\"hidden\" value=\"$v\" name=\"$k\">";
      } else {
        if ($isAdd)
          $ret .= "<input type=\"text\" placeholder=\"$k\" name=\"$k\">";
        else
          $ret .= "<input type=\"text\" value=\"$v\" placeholder=\"$k\" name=\"$k\">";
      }
    }
    if ($isAdd) {
      $ret .= '<input type="submit" name="' . $db_name . '" value="Ajouter"/>';
    } else {
      $ret .= '<input type="submit" name="' . $db_name . '" value="MaJ"/>';
      $ret .= '<input type="submit" name="' . $db_name . '" value="Supprimer"/>';
    }
    $ret .= '</form>';
    echo $ret;
  }
  echo '</div>';
};

function getAdd($database, $table)
{
  $data = $database->query("SELECT * FROM $table LIMIT 1")->fetchObject();
  $keys = [];
  foreach ($data as $k => $v) array_push($keys, $k);
  if (isset($_POST[$table]) && $_POST[$table] == 'Ajouter') {
    try {
      $sql = "INSERT INTO $table (";
      for ($i = 0; $i < count($keys); $i++) {
        $sql .= $keys[$i];
        if ($i + 1 != count($keys)) $sql .= ',';
        $sql .= " ";
      }
      $sql .= ') VALUES (';
      for ($i = 0; $i < count($keys); $i++) {
        $sql .= '"' . $_POST[$keys[$i]] . '"';
        if ($i + 1 != count($keys)) $sql .= ',';
        $sql .= " ";
      }
      $sql .= ');';
      $stmt = $database->prepare($sql);
      $stmt->execute();
      $stmt->rowCount() . " record(s) ADDED </div>";
    } catch (PDOException $e) {
      $e->getMessage() . '</div>';
    }
  }
};

function getUpdate($database, $table, $where)
{
  $data = $database->query("SELECT * FROM $table LIMIT 1")->fetchObject();
  $keys = [];
  foreach ($data as $k => $v) array_push($keys, $k);
  if (isset($_POST[$table]) && $_POST[$table] == 'MaJ') {
    try {
      $sql = "UPDATE $table SET ";
      for ($i = 0; $i < count($keys); $i++) {
        if (!in_array($keys[$i], [$where])) {
          $sql .= $keys[$i] . "=\"" . $_POST[$keys[$i]] . '"';
          if ($i + 1 != count($keys)) $sql .= ',';
          $sql .= ' ';
        }
      }
      $sql .= "WHERE $where = $_POST[$where];";
      $stmt = $database->prepare($sql);
      $stmt->execute();
      $stmt->rowCount() . ' rows updated</div>';
    } catch (PDOException $e) {
      $e->getMessage() . '</div>';
    }
  }
};


function getDelete($database, $table, $where)
{
  if (isset($_POST[$table]) && $_POST[$table] == 'Supprimer') {
    try {
      $table_length = (int) $database->query("SELECT COUNT(*) FROM $table")->fetchColumn();
      if ($table_length > 1) {
        $sql = "DELETE FROM $table WHERE $where=" . $_POST[$where];
        $stmt = $database->prepare($sql);
        $stmt->execute();
        $stmt->rowCount() . ' rows updated</div>';
      }
    } catch (PDOException $e) {
      $e->getMessage() . '</div>';
    }
  }
};

$database = getDatabase('php_loto', 'root', '');
$database->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);